<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Hamming Code Encoder</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            text-align: center;
        }
        #output, #decodedOutput {
            font-weight: bold;
            color: green;
        }
    </style>
</head>
<body>
    <h1>Hamming Code Encoder</h1>
    <label for="data">Geben Sie die Nutzdaten in Binärform ein:</label>
    <input type="text" id="data" placeholder="1111">
    <button onclick="encodeData()">Codieren</button>
    <p style="display:none;" id="wrongInput"></p>
    <div id="explaination" style="display:none">
    <p id="enteredData"></p>
    <p id="algorithm"></p>
    <p id="fill-data"></p>
    <ul style="display: flex; align-items: center; flex-direction: column;" id="parity-bits"></ul>
    <p id="hammingResult"></p>
    <p id="removeZeros"></p>
    <p id="output"></p>
    </div>

<script>
    function hamming_encode(data, r) {
    let n = Math.pow(2, r) - 1; 
    let k = n - r;

    if (data.length !== k) {
        throw new Error(`Die Länge der Daten sollte ${k} sein.`);
    }

    let encoded_data = Array(n).fill(0);

    let j = 0;
    for (let i = 0; i < n; i++) {
        if (!((2**Math.floor(Math.log2(i+1))) - 1 === i)) {
            encoded_data[i] = parseInt(data[j]);
            j++;
        }
    }

    document.getElementById('parity-bits').innerHTML = '';
    for (let i = 0; i < r; i++) {
        let parity_pos = Math.pow(2, i) - 1;
        let start = parity_pos;
        let skip = Math.pow(2, i);
        let parity = 0;

        while (start < n) {
            for (let s = 0; s < skip; s++) {
                if (start + s < n) {
                    parity ^= encoded_data[start + s];
                }
            }
            start += 2 * skip;
        }
        document.getElementById('parity-bits').innerHTML += '<li>Paritätsbit ' + (i + 1) + ' an Position ' + (parity_pos + 1) + ' wird berechnet: ' + parity + '</li>';
        encoded_data[parity_pos] = parity;
    }

    return encoded_data.join('');
}

function hamming_decode(encoded_data, r) {
    let n = Math.pow(2, r) - 1;

    if (encoded_data.length !== n) {
        throw new Error(`Die Länge der encodierten Daten sollte ${n} sein.`);
    }

    encoded_data = encoded_data.split('').map(x => parseInt(x));

    let error_pos = 0;
    document.getElementById('parity-bits-decoding').innerHTML = '';
    for (let i = 0; i < r; i++) {
        let parity_pos = Math.pow(2, i) - 1;
        let start = parity_pos;
        let skip = Math.pow(2, i);
        let parity = 0;

        while (start < n) {
            for (let s = 0; s < skip; s++) {
                if (start + s < n) {
                    parity ^= encoded_data[start + s];
                }
            }
            start += 2 * skip;
        }
        document.getElementById('parity-bits-decoding').innerHTML += '<li>Paritätsbit ' + (i + 1) + ' an Position ' + (parity_pos + 1) + ' wird berechnet: ' + parity + '</li>';
        if (parity !== 0) {
            error_pos += Math.pow(2, i);
        }
    }

    if (error_pos !== 0) {
        encoded_data[error_pos - 1] ^= 1;
        document.getElementById('errorPos').innerHTML = 'Es wurde ein Fehler an der Position ' + error_pos + ' gefunden: ' + encoded_data.join('');
    } else {
        document.getElementById('errorPos').innerHTML = 'Es wurde kein Fehler gefunden.';
    }

    let decoded_data = encoded_data.filter((_, i) => !((2**Math.floor(Math.log2(i+1))) - 1 === i));
    return decoded_data.join('');
}

function encode_data(data, r) {
    let k = Math.pow(2, r) - r - 1;
    let length = data.length + r;

    if (data.length > k) {
        throw new Error(`Die Daten sollten eine Länge von maximal ${k} haben.`);
    }
    if(data.length < k){
        document.getElementById('fill-data').innerHTML = 'Die Nutzdaten werden mit Nullen aufgefüllt: ';
    } else {
        document.getElementById('fill-data').innerHTML = '';
    }
    while (data.length < k) {
        data += '0';
    }
    if(document.getElementById('fill-data').innerHTML != ''){
        document.getElementById('fill-data').innerHTML += data;
    } else {
        document.getElementById('fill-data').innerHTML = 'Die Nutzdaten werden nicht mit Nullen aufgefüllt';
    }

    let hamming_cal = hamming_encode(data, r);
    document.getElementById('hammingResult').innerHTML = 'Die Paritätsbits werden an der entsprechenden Stelle eingesetzt: ' + hamming_cal;
    if(length != hamming_cal.length){
        document.getElementById('removeZeros').innerHTML = 'Die überschüssigen Nullen werden wieder entfernt.';
    } else {
        document.getElementById('removeZeros').innerHTML = 'Es werden keine überschüssigen Nullen entfernt.';
    }
    return hamming_cal.substring(0, length);
}

function decode_data(encoded_data, r) {
    let k = Math.pow(2, r) - 1;
    let original_length = encoded_data.length - r;

    if(encoded_data.length < k){
        document.getElementById('fill-encoded-data').innerHTML = 'Die encodierten Daten werden mit Nullen aufgefüllt: ';
    } else {
        document.getElementById('fill-encoded-data').innerHTML = '';
    }
    if (encoded_data.length > k) {
        throw new Error(`Die Daten sollten eine Länge von maximal ${k} haben.`);
    }
    while (encoded_data.length < k) {
        encoded_data += '0';
    }
    if(document.getElementById('fill-encoded-data').innerHTML != ''){
        document.getElementById('fill-encoded-data').innerHTML += encoded_data;
    } else {
        document.getElementById('fill-encoded-data').innerHTML = 'Die encodierten Daten werden nicht mit Nullen aufgefüllt';
    }

    let decoded = hamming_decode(encoded_data, r);
    document.getElementById('hamming-decode-result').innerHTML = 'Die Paritätsbits werden entfernt: ' + decoded;
    if(original_length != decoded.length){
        document.getElementById('decodedRemoveZeros').innerHTML = 'Die überschüssigen Nullen werden wieder entfernt.';
    } else {
        document.getElementById('decodedRemoveZeros').innerHTML = 'Es werden keine überschüssigen Nullen entfernt.';
    }
    return decoded.substring(0, original_length);
}

function encode(data) {
    let r = 2;
    while (data.length > Math.pow(2, r) - r - 1) {
        r++;
    }
    document.getElementById('algorithm').innerHTML = 'Es wird der Hamming(' + (Math.pow(2, r) - 1) + ', ' + (Math.pow(2, r) - r - 1) + ')-Code verwendet.';
    return encode_data(data, r);
}

function decode(data) {
    let r = 2;
    while (data.length > Math.pow(2, r) - 1) {
        r++;
    }
    document.getElementById('decodingAlgorithm').innerHTML = 'Es wird der Hamming(' + (Math.pow(2, r) - 1) + ', ' + (Math.pow(2, r) - r - 1) + ')-Code verwendet.';
    return decode_data(data, r);
}

</script>

    <script>
    function encodeData() {
        const dataInput = document.getElementById('data').value;
        const data = dataInput.replace(/[^0-1]/g, '');
        if(data.length < 1){
            document.getElementById('wrongInput').innerHTML = 'Die Länge der Daten muss mindestens 1 sein.';
            document.getElementById('explaination').style.display = 'none';
            document.getElementById('wrongInput').style.display = 'block';
            return;
        }
        document.getElementById('wrongInput').style.display = 'none';
        document.getElementById('explaination').style.display = 'block';
        const enteredData = document.getElementById('enteredData');
        enteredData.innerHTML = 'Eingegebene Daten: ' + data;
        const encodedData = encode(data);
        const outputElement = document.getElementById('output');
        outputElement.innerHTML = 'Encodierter Code: ' + encodedData;
    }
    </script>
    <h1>Hamming Code Decoder</h1>
    <label for="encodedData">Geben Sie die encodierten Daten in Binärform ein:</label>
    <input type="text" id="encodedData" placeholder="1111111">
    <button onclick="decodeData()">Decodieren</button>
    <p style="display:none;" id="decodingWrongInput"></p>
    <div id="decodingExplaination" style="display:none">
    <p id="enteredEncodedData"></p>
    <p id="decodingAlgorithm"></p>
    <p id="fill-encoded-data"></p>
    <ul style="display: flex; align-items: center; flex-direction: column;" id="parity-bits-decoding"></ul>
    <p id="errorPos"></p>
    <p id="hamming-decode-result"></p>
    <p id="decodedRemoveZeros"></p>
    <p id="decodedOutput"></p>
    </div>
    <script>
    function decodeData() {
        const encodedInput = document.getElementById('encodedData').value;
        const encoded = encodedInput.replace(/[^0-1]/g, '');
        if(Math.log2(encoded.length)%1 == 0){
            document.getElementById('decodingWrongInput').innerHTML = 'Die Länge der Daten darf keiner Zweier-Potenz entsprechen.';
            document.getElementById('decodingExplaination').style.display = 'none';
            document.getElementById('decodingWrongInput').style.display = 'block';
            return;
        } else if(encoded.length < 1){
            document.getElementById('decodingWrongInput').innerHTML = 'Die Länge der Daten muss mindestens 1 sein.';
            document.getElementById('decodingExplaination').style.display = 'none';
            document.getElementById('decodingWrongInput').style.display = 'block';
            return;
        }
        document.getElementById('decodingWrongInput').style.display = 'none';
        document.getElementById('decodingExplaination').style.display = 'block';
        const enteredEncodedData = document.getElementById('enteredEncodedData');
        enteredEncodedData.innerHTML = 'Eingegebene Daten: ' + encoded;
        const encodedData = decode(encoded);
        const outputElement = document.getElementById('decodedOutput');
       outputElement.innerHTML = 'Decodierter Code: ' + encodedData;
    }
    </script>
</body>
</html>
